"""
@author: luojunhui
"""

import datetime

from applications import log
from coldStartTasks.ai_pipeline import GenerateTextFromVideo


def main():
    task = GenerateTextFromVideo()

    # 查询有多少任务正在处理中
    processing_tasks = task.get_processing_task_num()

    if processing_tasks:
        print(
            f"{datetime.datetime.now()} 当前有 {processing_tasks} 个任务正在等待 google 处理..."
        )
        task.convert_video_to_text_with_google_ai_task()
    else:
        print(f"{datetime.datetime.now()} 没有任务正在处理中...")
        # upload video to google ai
        task.upload_video_to_google_ai_task()
        log(
            task="video_understanding_with_google",
            function="main",
            message="upload_video_to_google_ai_task",
        )
        task.convert_video_to_text_with_google_ai_task()


if __name__ == "__main__":
    main()
